/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "ns3/core-module.h"
#include "ns3/simulator-module.h"
#include "ns3/node-module.h"
#include "ns3/helper-module.h"
#include "ns3/leaky-bucket-helper.h"
#include "ns3/flow-monitor-module.h"

// Default Network Topology
/*
//       
//       n2                              n5
//         \ 10.1.2.0                   / 10.1.5.0
//          \                          /
//           \                        /
//            \                      /
//   10.1.3.0  \      10.1.1.0      /
// n3 --------- n0 -------------- n1
//             /                    \
//            /                      \
//           /                        \
//          /                          \
//         /10.1.4.0                    \ 10.1.6.0
//       n4                              n6
// 
*/
using namespace ns3;

NS_LOG_COMPONENT_DEFINE ("SecondScriptExample");

int 
main (int argc, char *argv[])
{

/////////////////////////////////////////////////////////
//Orismos twn kombwn pou briskontai aristera tou n0
//
//
//
//Orismos tou n2
  NodeContainer p2pNodes2;
  p2pNodes2.Create (2);

  PointToPointHelper pointToPoint2;
  pointToPoint2.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
  //pointToPoint2.SetChannelAttribute ("Delay", StringValue ("2ms"));

  NetDeviceContainer p2pDevices2;
  p2pDevices2 = pointToPoint2.Install (p2pNodes2);

//Orismos tou n3
  NodeContainer p2pNodes3;
  p2pNodes3.Create (1);
  p2pNodes3.Add (p2pNodes2.Get (1));
  

  PointToPointHelper pointToPoint3;
  pointToPoint3.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
  //pointToPoint3.SetChannelAttribute ("Delay", StringValue ("2ms"));

  NetDeviceContainer p2pDevices3;
  p2pDevices3 = pointToPoint3.Install (p2pNodes3);

//Orismos tou n4
  NodeContainer p2pNodes4;
  p2pNodes4.Create (1);
  p2pNodes4.Add (p2pNodes2.Get (1));
  

  PointToPointHelper pointToPoint4;
  pointToPoint4.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
  //pointToPoint.SetChannelAttribute ("Delay", StringValue ("2ms"));

  NetDeviceContainer p2pDevices4;
  p2pDevices4 = pointToPoint4.Install (p2pNodes4);
//
//
//
////////////////////////////////////////////////////////////


//Orismos twn helper kai twn idiotitwn twn router no kai n1
//
//
//
  NodeContainer p2pNodes01;
  p2pNodes01.Add (p2pNodes2.Get (1));
  p2pNodes01.Create (1);
  
  PointToPointHelper pointToPoint01;
  pointToPoint01.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
  //pointToPoint01.SetChannelAttribute ("Delay", StringValue ("2ms"));

  NetDeviceContainer p2pDevices01;
  p2pDevices01 = pointToPoint01.Install (p2pNodes01);
//
//
//////////////////////////////////////////////////////////////



//Orismos twn kombwn pou briskontai deksia tou n1
//
//
//
//Orismos tou n5
  NodeContainer p2pNodes5;
  p2pNodes5.Create (1);
  p2pNodes5.Add (p2pNodes01.Get (1));

  PointToPointHelper pointToPoint5;
  pointToPoint5.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
  //pointToPoint2.SetChannelAttribute ("Delay", StringValue ("2ms"));

  NetDeviceContainer p2pDevices5;
  p2pDevices5 = pointToPoint5.Install (p2pNodes5);

//Orismos tou n6
  NodeContainer p2pNodes6;
  p2pNodes6.Create (1);
  p2pNodes6.Add (p2pNodes01.Get (1));
  

  PointToPointHelper pointToPoint6;
  pointToPoint6.SetDeviceAttribute ("DataRate", StringValue ("10Mbps"));
  //pointToPoint3.SetChannelAttribute ("Delay", StringValue ("2ms"));

  NetDeviceContainer p2pDevices6;
  p2pDevices6 = pointToPoint6.Install (p2pNodes6);
//
//
//
///////////////////////////////////////////////////////////


  InternetStackHelper stack;
  stack.Install (p2pNodes2.Get (0));
  stack.Install (p2pNodes3.Get (0));
  stack.Install (p2pNodes4.Get (0));
  stack.Install (p2pNodes01);
  stack.Install (p2pNodes5.Get (0));
  stack.Install (p2pNodes6.Get (0));

  Ipv4AddressHelper address;
  address.SetBase ("10.1.2.0", "255.255.255.0");
  Ipv4InterfaceContainer p2pInterfaces2;
  p2pInterfaces2 = address.Assign (p2pDevices2);

  address.SetBase ("10.1.3.0", "255.255.255.0");
  Ipv4InterfaceContainer p2pInterfaces3;
  p2pInterfaces3 = address.Assign (p2pDevices3);

  address.SetBase ("10.1.4.0", "255.255.255.0");
  Ipv4InterfaceContainer p2pInterfaces4;
  p2pInterfaces4 = address.Assign (p2pDevices4);
  
  address.SetBase ("10.1.1.0", "255.255.255.0");
  Ipv4InterfaceContainer p2pInterfaces01;
  p2pInterfaces01 = address.Assign (p2pDevices01);

  address.SetBase ("10.1.5.0", "255.255.255.0");
  Ipv4InterfaceContainer p2pInterfaces5;
  p2pInterfaces5 = address.Assign (p2pDevices5);

  address.SetBase ("10.1.6.0", "255.255.255.0");
  Ipv4InterfaceContainer p2pInterfaces6;
  p2pInterfaces6 = address.Assign (p2pDevices6);

//Dhmiourgia kinhshs sto diktuo meso ths OnOff application
  ApplicationContainer apps0;
  OnOffHelper onOffHelper0  ("ns3::UdpSocketFactory", InetSocketAddress (Ipv4Address ("10.1.5.2"), 9));      
  onOffHelper0.SetAttribute ("DataRate", StringValue ("10Mbps"));                                           
  onOffHelper0.SetAttribute ("PacketSize", UintegerValue (1024));      
  onOffHelper0.SetAttribute ("MaxBytes", UintegerValue (10240));                                          
  onOffHelper0.SetAttribute ("OnTime",  RandomVariableValue (ConstantVariable (1)));                        
  onOffHelper0.SetAttribute ("OffTime", RandomVariableValue (ConstantVariable (0)));                     
  apps0.Add(onOffHelper0.Install (p2pNodes4.Get (0)));     

  ApplicationContainer apps1;
  OnOffHelper onOffHelper1  ("ns3::UdpSocketFactory", InetSocketAddress (Ipv4Address ("10.1.6.2"), 9));      
  onOffHelper1.SetAttribute ("DataRate", StringValue ("10Mbps"));                                           
  onOffHelper1.SetAttribute ("PacketSize", UintegerValue (1024));      
  onOffHelper1.SetAttribute ("MaxBytes", UintegerValue (10240));                                          
  onOffHelper1.SetAttribute ("OnTime",  RandomVariableValue (ConstantVariable (1)));                        
  onOffHelper1.SetAttribute ("OffTime", RandomVariableValue (ConstantVariable (0)));                     
  apps1.Add(onOffHelper1.Install (p2pNodes2.Get (0)));  

  ApplicationContainer apps2;
  OnOffHelper onOffHelper2  ("ns3::UdpSocketFactory", InetSocketAddress (Ipv4Address ("10.1.1.2"), 9));      
  onOffHelper2.SetAttribute ("DataRate", StringValue ("10Mbps"));                                           
  onOffHelper2.SetAttribute ("PacketSize", UintegerValue (1024));      
  onOffHelper2.SetAttribute ("MaxBytes", UintegerValue (10240));                                          
  onOffHelper2.SetAttribute ("OnTime",  RandomVariableValue (ConstantVariable (1)));                        
  onOffHelper2.SetAttribute ("OffTime", RandomVariableValue (ConstantVariable (0)));                     
  apps2.Add(onOffHelper2.Install (p2pNodes3.Get (0))); 

  ApplicationContainer apps3;
  OnOffHelper onOffHelper3  ("ns3::UdpSocketFactory", InetSocketAddress (Ipv4Address ("10.1.2.1"), 9));      
  onOffHelper3.SetAttribute ("DataRate", StringValue ("10Mbps"));                                           
  onOffHelper3.SetAttribute ("PacketSize", UintegerValue (1024));      
  onOffHelper3.SetAttribute ("MaxBytes", UintegerValue (10240));                                          
  onOffHelper3.SetAttribute ("OnTime",  RandomVariableValue (ConstantVariable (1)));                        
  onOffHelper3.SetAttribute ("OffTime", RandomVariableValue (ConstantVariable (0)));                     
  apps3.Add(onOffHelper3.Install (p2pNodes5.Get (0))); 


////////Orismos twn leaky buckets gia tous n0 kai n1//////////
//
//
//
//Egkatastash ston kombo n0 ena leaky me ta akoloutha xarakthristika
//morfopoiwntas thn kinisi pou eiserxetai sto diktuo apo ton n2( me ip: 10.1.2.1)
 LeakyBucketHelper myBucket;
  myBucket.SetAttribute ("DataRate", StringValue ("1Mbps")); 
  myBucket.SetAttribute ("Ipv4Shape", Ipv4AddressValue ("10.1.2.1")); 
  myBucket.SetAttribute ("MaxPackets", UintegerValue (5)); 
  myBucket.Install(p2pDevices2.Get(1));

//Egkatastash ston kombo n0 ena leaky me ta akoloutha xarakthristika
//morfopoiwntas thn kinisi pou eiserxetai sto diktuo apo ton n4( me ip: 10.1.4.1)
LeakyBucketHelper myBucket2;
  myBucket2.SetAttribute ("DataRate", StringValue ("5Mbps")); 
  myBucket2.SetAttribute ("Ipv4Shape", Ipv4AddressValue ("10.1.4.1")); 
  myBucket2.SetAttribute ("MaxPackets", UintegerValue (5)); 
  myBucket2.Install(p2pDevices4.Get(1));

//Egkatastash ston kombo n1 ena leaky me ta akoloutha xarakthristika
//morfopoiwntas thn kinisi pou eiserxetai sto diktuo apo ton n5( me ip: 10.1.5.1)
LeakyBucketHelper myBucket3;
  myBucket3.SetAttribute ("DataRate", StringValue ("2Mbps")); 
  myBucket3.SetAttribute ("Ipv4Shape", Ipv4AddressValue ("10.1.5.1")); 
  myBucket3.SetAttribute ("MaxPackets", UintegerValue (2)); 
  myBucket3.Install(p2pDevices5.Get(1));
//
//
//
////////////////////////////////////////////////



  Ipv4GlobalRoutingHelper::PopulateRoutingTables ();

 /*========================================FlowMonitorHelper=================================================*/
  FlowMonitorHelper flowmon;
  Ptr<FlowMonitor> monitor = flowmon.InstallAll();

  Simulator::Stop (Seconds (30.0));
  Simulator::Run ();
/*================================Print per flow statistics=================================================*/
  monitor->CheckForLostPackets ();
  Ptr<Ipv4FlowClassifier> classifier = DynamicCast<Ipv4FlowClassifier> (flowmon.GetClassifier ());
  std::map<FlowId, FlowMonitor::FlowStats> stats = monitor->GetFlowStats ();
  for (std::map<FlowId, FlowMonitor::FlowStats>::const_iterator i = stats.begin (); i != stats.end (); ++i)
    {
      Ipv4FlowClassifier::FiveTuple t = classifier->FindFlow (i->first);
      std::cout << "Flow " << i->first << " (" << t.sourceAddress << " -> " << t.destinationAddress << ")\n";
      std::cout << "  Tx Bytes:   " << i->second.txBytes << "\n";
      std::cout << "  Rx Bytes:   " << i->second.rxBytes << "\n";
      std::cout << "  Tx Packets:  " << i->second.txPackets << "\n";
      std::cout << "  Rx Packets:  " << i->second.rxPackets << "\n";
      std::cout << "  delaySum:  " << i->second.delaySum << "\n"; 
    }

 Simulator::Destroy ();
  return 0;
}
