/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Author: Baltzis Petros<mpaltzis@ceid.upatras.gr>

#include "leaky-bucket-helper.h"
#include "ns3/leaky-bucket.h"
#include "ns3/node.h"
#include "ns3/inet-socket-address.h"
#include "ns3/packet-socket-address.h"
#include "ns3/net-device.h"


namespace ns3 {

LeakyBucketHelper::LeakyBucketHelper ()
{
  m_factory.SetTypeId ("ns3::LeakyBucket");
}

//Gia ton orismo enos sunolou apo idiotites gia kapoio leaku bucket
void 
LeakyBucketHelper::SetAttribute (std::string name, const AttributeValue &value)
{
  m_factory.Set (name, value);
}

//H sunarthsh install kaleitai kata ton sxediasmo mias topologias kai pernei ws
//orisma enan deikti se ena netDevice.Etsi me auton ton tropo egkathisatatai ena 
//leaky bucket gia enan kombo.
void
LeakyBucketHelper::Install (Ptr<NetDevice> ShapedDevice) const
{
  Ptr<Node> ShapedNode = ShapedDevice->GetNode();
  Ptr<LeakyBucket> leaky = m_factory.Create<LeakyBucket> ();
  ShapedNode->AddShaper (leaky, ShapedDevice);

}

} // namespace ns3
